
#include "bits/bitrotate.h"
#include "bits/parity.h"

#include "bmat/bitmat-inline.h"

#include "fxttypes.h"  // ulong
//#include "bits/printbin.h"
//#include "fxtiomanip.h"


ulong
normal_mult(ulong a, ulong b, const ulong *M, ulong n)
// Multiply two elements (a and b in GF(2^n)) in normal basis representation.
// The multiplication matrix has to be supplied in M.
{
    ulong p = 0;
//    cout << endl; cout << "+++++++++++++++++++" << endl;
    for (ulong k=0; k<n; ++k)
    {
        ulong v = bitmat_mult_Mv(M, n, b);
        v = parity( v & a );  // dot product
//        p <<= 1; p ^= v;
        p ^= ( v << k );
        a = bit_rotate_right(a, 1, n);
        b = bit_rotate_right(b, 1, n);
    }
    return  p;
}
// -------------------------
